<template>
  <div class="browse-container">
    <div class="buttons" style="margin-top: 1rem;">
      Select a study: <select v-model="selected_study" @change="loadFiles">
        <option v-for="study in all_studies" :value="study.study_id">
          {{ study.study_name }}
        </option>
      </select>
      Select procedure: <select v-model="selected_procedure" @change="loadFiles">
        <option value="qcplot_metabolite">Quality Control Plot (by metabolite)</option>
        <option value="qcplot_source">Quality Control Plot (by source)</option>
        <option value="plot_pearson">Pearson Correlation Heatmap</option>
        <option value="raw_spectra">Plot Bruker NMR spectra</option>
      </select>
      <select v-if="['qcplot_metabolite', 'qcplot_source'].includes(selected_procedure)" v-model="over_lod">
        <option selected value="true">&gt;LOD</option>
        <option selected value="false">&lt;LOD</option>
      </select>
      <button v-if="selected_procedure != 'raw_spectra'" @click="executeProcedure">Execute</button>
      <VueSpinnerGears v-if="loading && selected_procedure != 'raw_spectra'" size="24" color="var(--color-primary)"></VueSpinnerGears>
    </div>
    <div v-if="selected_procedure == 'raw_spectra'" class="spectra-selection">
      <span>Please select the according NMR results, make sure that they are stored in a <b>compressed manner</b> (preferably zip).</span>
      <span>We use the R package <a href="https://cran.r-project.org/web/packages/mrbin/">mrbin</a> for extracting Bruker NMR data.</span>
      <select v-model="spectra_file">
        <option v-for="file in available_files" :value="file">{{ file }}</option>
      </select>
      <div class="buttons" style="margin-top: 0.5rem;">
        <button @click="executeProcedure">Execute</button>
        <VueSpinnerGears v-if="loading" size="24" color="var(--color-primary)"></VueSpinnerGears>
      </div>
    </div>
    <div class="plot-wrapper">
      <PlotItem v-if="selected_procedure == 'plot_pearson'" :plot_id="query.query_plot_ids.correlation" plot_type="correlation"></PlotItem>
      <PlotItem v-if="selected_procedure == 'qcplot_metabolite'" :plot_id="query.query_plot_ids.qcplot_met" plot_type="qcplot_met"></PlotItem>
      <PlotItem v-if="selected_procedure == 'qcplot_source'" :plot_id="query.query_plot_ids.qcplot_src" plot_type="qcplot_src"></PlotItem>
      <PlotItem v-if="selected_procedure == 'raw_spectra'" :plot_id="query.query_plot_ids.spectra" plot_type="bruker"></PlotItem>
      <div v-if="['qcplot_metabolite', 'qcplot_source', 'raw_spectra'].includes(selected_procedure)" style="font-size: var(--fs-small);">This process can take a while depending on the size of your dataset.
       If the image is too large, please right click it and select "Open image in new tab".</div>
    </div>
    
  </div>
  

</template>

<script setup lang="ts">
import { generateBrukerPlot, generateCorrelationPlotFromScratch, generateQCPlotMetabolitesFromScratch, generateQCPlotSourcesFromScratch } from '@/modules/query_module';
import { getStudyExperimentalFilenames, getStudyList } from '@/modules/study_module';
import { useQueryStore } from '@/stores/query';
import { useStudyStore, type StudyData } from '@/stores/studies';
import { ref, onMounted } from 'vue';
import { VueSpinnerGears } from 'vue3-spinners';
import PlotItem from '@/components/plot/PlotItem.vue';
import type { Message } from '@/stores/message';
const studies = useStudyStore();
const query = useQueryStore();

onMounted(async () => {
    await refreshStudies();
    if (all_studies.value?.length)
      selected_study.value = all_studies.value[0].study_id;
})

const executeProcedure = async () => {
  loading.value = true;
  switch(selected_procedure.value) {
    case "qcplot_metabolite":
      await createNewQCPlotMet();
      break;
    case "qcplot_source":
      await createNewQCPlotSrc();
      break;
    case "plot_pearson":
      await createNewHeatmap();
      break;
    case "raw_spectra":
      await createBrukerPlot();
      break;
    default:
      loading.value = false;
      break;
  }
}

const loadFiles = async() => {
  if (selected_procedure.value != 'raw_spectra') return;
  available_files.value = (await getStudyExperimentalFilenames(selected_study.value) as Message).body;
}

const createNewHeatmap = async () => {
    let potential_id: string|undefined = await generateCorrelationPlotFromScratch(selected_study.value);
    if (potential_id) {
        query.query_plot_ids.correlation = potential_id;
        console.log(query.query_plot_ids)
    }
    loading.value = false;
}

const createNewQCPlotMet = async () => {
    let potential_id: string|undefined = await generateQCPlotMetabolitesFromScratch(over_lod.value, selected_study.value);
    if (potential_id) {
        query.query_plot_ids.qcplot_met = potential_id;
    }
    loading.value = false;
}

const createNewQCPlotSrc = async () => {
    let potential_id: string|undefined = await generateQCPlotSourcesFromScratch(over_lod.value, selected_study.value);
    if (potential_id) {
        query.query_plot_ids.qcplot_src = potential_id;
    }
    loading.value = false;
}

const createBrukerPlot = async () => {
    if (!spectra_file.value) return;
    let potential_id: string|undefined = await generateBrukerPlot(selected_study.value, spectra_file.value);
    if (potential_id) {
        query.query_plot_ids.spectra = potential_id;
        console.log(query.query_plot_ids)
    }
    loading.value = false;
}


const refreshStudies = async () => {
    await getStudyList();
    if (studies.studies_owned)
        all_studies.value = studies.studies_owned;
    if (studies.studies_shared)
        all_studies.value = all_studies.value?.concat(studies.studies_shared);
    if (studies.studies_public)
        all_studies.value = all_studies.value?.concat(studies.studies_public);
}

const all_studies = ref<StudyData[]|undefined>([]);
const selected_study = ref<string>("");
const selected_procedure = ref<string>("qcplot_metabolite");
const over_lod = ref<string>("true");
const available_files = ref<string[]|null>();
const spectra_file = ref<string|null>();
const loading = ref<boolean>(false);
</script>

<style scoped>

.browse-container {
    display: flex;
    justify-items: baseline;
    flex-direction: column;
    min-width: 65%;
    max-width: 100%;
    margin: 5.5rem auto;
}

.plot-wrapper {
    display: flex;
    align-items: center;
    flex-direction: column;
    row-gap: 4rem;
    margin-top: 2rem;
}

.spectra-selection {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  margin-top: 1rem;
}

a, a:active {
    color: var(--color-primary);
}

a:hover {
    color: var(--color-head);
}


</style>